#include "robber.h"
#include <iostream>
#include <iterator>
#include <cmath>

using namespace std;
using namespace __gnu_cxx;

string Robber::turn(){
	hash_map<string,double> streets;
	Intersection& inter = _intersections[_location];
	for (hash_map<string,StreetType>::const_iterator street = inter.connections.begin();
               street != inter.connections.end(); ++street){
		double goodness = 100;
		int curx = _intersections[_location].x;
		int cury = _intersections[_location].y;

		int newx = _intersections[street->first].x;
		int newy = _intersections[street->first].y;
		for (hash_map<string, Player>::const_iterator player = _players.begin();
				player != _players.end(); ++player){
			if (player->first == _name)
				continue;

			int px = _intersections[player->second.location].x;
			int py = _intersections[player->second.location].y;

			double dist1 = sqrt(pow((curx-px),2.0)+pow((cury-py),2.0));
			double dist2 = sqrt(pow((newx-px),2.0)+pow((newy-py),2.0));
			cerr << "Original distance: " << dist1 << endl;
			cerr << "New distance: " << dist2 << endl;


			if (dist2 > dist1)
				goodness *= 4;
			else
				goodness /= 4;

			if (player->second.type == "cop-foot" && dist2 <= 3)
				goodness /= 10;
			else if (player->second.type == "cop-car" && dist2 <= 2)
				goodness /= 10;


		}
		streets[street->first] = goodness;
	}

	for(hash_map<string,int>::const_iterator bank = _banks.begin();
			bank != _banks.end(); ++bank){
		//cerr << "Handling bank at: " << bank->first << endl;
		if (bank->second > 0){
			vector<string> v = shortestPath(_location, bank->first,_type);
			if (v.size() < 2)
				continue;
			streets[v[1]] *= bank->second/v.size();
			
		}
	}
	/*cerr << "Using route: ";
	copy(v.begin(), v.end(), ostream_iterator<string>(cerr, " : "));
	cerr << endl;
	*/

	string destination;
	double goodness = 0;
	for (hash_map<string,double>::const_iterator dest = streets.begin();
			dest != streets.end(); ++dest){
		cerr << "Goodness: " << dest->second << endl;
		if (dest->second > goodness){
		cerr << "New Goodness: " << dest->second << endl;
			goodness = dest->second;
			destination = dest->first;
		}
	}
		
	return destination;
	
}

int main(){
	Robber robber("robber");
	robber.play();

	return 0;
}
